import java.util.ArrayList; 

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
import java.util.Scanner;
// #[regen=yes,id=DCE.89FE530E-0CE1-8738-9960-6CB9968E4852]
// </editor-fold> 
public class Jugador {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.ADB46D97-1D82-C90A-A6A1-F4D1F1739BA7]
    // </editor-fold> 
    private Partida mJuego;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.E5DB353A-6B8E-7792-BB6A-28AD4097E4B8]
    // </editor-fold> 
    private Territorio miCapital;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.964FD058-A1B8-5C93-CDE4-3C2006B96801]
    // </editor-fold> 
    private CartaMision mCartaMision;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.DE4DF99F-72B3-1E67-9BBE-D34E511286CD]
    // </editor-fold> 
    private ArrayList<CartaDeTerritorio> mCartaDeTerritorio;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.50262C27-DD88-D8B4-53C3-C47D75BF91EF]
    // </editor-fold> 
    private ArrayList<CartaComodin> mCartaComodin;
    
    
    /*Variables creadas por nosotros*/
    private String nombre;
    private boolean objetivoCumplido;    
    private boolean turnoFinalizado;    
    private boolean abandonaPartida;    
    /********************************/
    
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.6CF75041-4622-42DB-30F3-0253643C8AB5]
    // </editor-fold> 
    public Jugador (){this("");}
    
    public Jugador (String nombre) 
    {
        System.out.println("Se crea el Jugador " + nombre);
        
        this.nombre = nombre;
        objetivoCumplido = false;
        turnoFinalizado = false;
        abandonaPartida = false;                
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.C42A72F7-B58D-440E-979E-357BC49D11C7]
    // </editor-fold> 
    public ArrayList<CartaComodin> getCartaComodin () {
        return mCartaComodin;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.EEA89667-C255-6F4F-E2BA-A6AB2F399A9D]
    // </editor-fold> 
    public void setCartaComodin (ArrayList<CartaComodin> val) {
        this.mCartaComodin = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.7178C3DA-56F1-3435-E3E6-D656B05088B5]
    // </editor-fold> 
    public ArrayList<CartaDeTerritorio> getCartaDeTerritorio () {
        return mCartaDeTerritorio;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.219C2E17-8E47-53A9-EC2E-810B1BF3BAF0]
    // </editor-fold> 
    public void setCartaDeTerritorio (ArrayList<CartaDeTerritorio> val) {
        this.mCartaDeTerritorio = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.18E3F3AD-AD04-200B-4196-104CFAB3EF93]
    // </editor-fold> 
    public CartaMision getCartaMision () {
        return mCartaMision;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1FC45CB5-CD68-31E8-7DBA-06CED77AAAD9]
    // </editor-fold> 
    public void setCartaMision (CartaMision val) {
        this.mCartaMision = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E2C8E837-5CFF-1B52-176E-EACDB725B1A6]
    // </editor-fold> 
    public Territorio getMiCapital () {
        return miCapital;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.76ADAF3F-D01D-5278-A913-939C8A17FFC1]
    // </editor-fold> 
    public void setMiCapital (Territorio val) {
        this.miCapital = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.2C2FB0A1-98A9-EEFF-AEB5-2852F9A09CA0]
    // </editor-fold> 
    public Partida getPartida () {
        return null;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.51EA5D13-32F4-EDCE-453B-5DB74B68EE86]
    // </editor-fold> 
    public void setPartida (Partida val) {
    }
    
    public boolean getObjetivoCumplido()
    {
        return objetivoCumplido;
    }
        
    public boolean getHaFinalizadoElTurno ()
    {
        return turnoFinalizado;
    }
    
    public void setHaFinalizadoElTurno (Boolean val)
    {
        turnoFinalizado = val;
    }
    
    public String getNombre ()
    {
        return nombre;
    }
    
    public void setNombre (String val)
    {
        nombre = val;
    }
    
    public boolean getAbandonaPartida()
    {
        return abandonaPartida;
    }
    
    public void setAbandonaPartida(Boolean val)
    {
        abandonaPartida = val;
    }
    
    public void finalizarTurno ()
    {        
        turnoFinalizado = true;
        System.out.println("El Jugador ha finalizado el turno");
        
        /*Se haran las operaciones oportunas para realizar el fin de turno*/
    }
    
    
    
    public void mover ()
    {                  
        setHaFinalizadoElTurno(false);
        
        while (!getHaFinalizadoElTurno())
        {            
            Scanner teclado = new Scanner(System.in);
            
            /*Mostramos un menu de opciones*/
            System.out.println("Indique la opcion a realizar:\n");
            /*System.out.println("Para atacar opcion 'a'");
            System.out.println("Para transferir opcion 't'");
            System.out.println("Para ubicar opcion 'u'");
            System.out.println("Para finalizar turno opcion 'f'");
            System.out.println("Para abandonar partida opcion 'A'\n");
            System.out.println("Opcion: ");*/
            
            switch (teclado.nextLine().charAt(0))
            {
                case 'a': 
                    System.out.println("El " + nombre + " ataca");
                    break;
                case 't': 
                    System.out.println("El " + nombre + " transfiere");
                    break;
                case 'u': 
                    System.out.println("El " + nombre + " ubica");
                    break;
                case 'A': 
                    System.out.println("El " + nombre + " Abandona la Partida");
                    setAbandonaPartida(true);
                    return;
                case 'f': 
                    finalizarTurno();
                    break;
            }
        }
    }

}

